package weblog;

import javax.servlet.*;
import javax.servlet.http.*;
import java.io.*;
import java.util.Enumeration;
import org.objectweb.jonathan.apis.kernel.Context;

public class WebLog extends HttpServlet {
   
   LogHandler handler = null;
   
   public WebLog() {
      Context initialContext = Startup.newConfiguration(WebLog.class);
      handler = (LogHandler)initialContext.getValue("Log Handler", (char)0);
   }

   public void doGet(HttpServletRequest _request, HttpServletResponse _response) throws ServletException, IOException {
      _response.setContentType("text/html; charset=iso-8859-1");
      PrintWriter $pw = _response.getWriter();

      printHeader($pw);
      for(Enumeration $e = handler.getEntries(); $e.hasMoreElements(); ) {
         String $entry = (String)$e.nextElement();
         $pw.println("<p>" + $entry + "</p>");
      }
      printInputForm($pw);
      printFooter($pw);

      $pw.flush();
   }

   public void doPost(HttpServletRequest _request, HttpServletResponse _response) throws ServletException, IOException {
      try {
         String $text = _request.getParameter("text");
         if ($text != null) handler.addEntry($text);
      } catch (Exception $ignored) {}
      doGet(_request, _response);
   }

   private void printHeader(PrintWriter _pw) {
      _pw.println("<!DOCTYPE HTML PUBLIC \"-//W3C//HTML 4.01 Transitional//EN\">");
      _pw.println("<html><head><title>WebLog</title>");
      _pw.println("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">");
      _pw.println("</head>");
      _pw.println("<body><h1>WebLog</h1>");
   }
   
   private void printFooter(PrintWriter _pw) {
      _pw.println("</body></html>");
   }
   
   private void printInputForm(PrintWriter _pw) {
      _pw.println("<hr width=\"75%\">");
      _pw.println("<form action=\"weblog\" method=\"POST\">");
      _pw.println("<table>");
      _pw.println("<tr><td><input type=\"text\" name=\"text\"></td>");
      _pw.println("</tr>");
      _pw.println("</table>");
      _pw.println("<br><input type=\"submit\" value=\"Send\">");
      _pw.println("</form>");
   }
}
