package weblog;

import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Enumeration;
import weblog.business.apis.EntriesReader;

public class LogHandler {

   private EntriesReader reader;
   private String[] levels;
   private DateFormat dateFormat;
   
   public LogHandler(EntriesReader _reader) {
      this(_reader, new String[]{"default"});
   }

   public LogHandler(EntriesReader _reader, String[] _levels) {
      reader = _reader;
      levels = _levels;
      //set a default DateFormat:
      dateFormat = new SimpleDateFormat();
   }

   public void setDatePattern(String _pattern) {
      dateFormat = new SimpleDateFormat(_pattern);
   }

   public Enumeration getEntries() {
      return reader.getEntries();
   }

   public String[] getLevels() {
      return levels;
   }

   public void addEntry(String _entry, String _level) {
      Date $currentTime = new Date();
      reader.addEntry(dateFormat.format($currentTime)+" - ["+_level+"] "+_entry);
   }

}
