package org.objectweb.jonathan.libs.kernel;

import junit.framework.*;
import  java.net.URLClassLoader;
import  java.net.URL;
import  java.io.File;

/**
 * Jonathan Test Suite
 */
public class ClassPathFinderImplTest extends TestCase {

   public ClassPathFinderImplTest(String name) {
      super(name);
   }

	public static void main(String args[]) {
		junit.textui.TestRunner.run(ClassPathFinderImplTest.class);
	}

   public void testLoadPrimitiveType() {
      ClassPathFinderImpl finder = new
            ClassPathFinderImpl(ClassPathFinderImplTest.class.getClassLoader());
      assertSame(int.class,finder.findClass("int"));
   }
    
   public void testLoadObjectType() {
      ClassPathFinderImpl finder = new
            ClassPathFinderImpl(ClassPathFinderImplTest.class.getClassLoader());
      assertSame(ClassPathFinderImplTest.class,
                 finder.findClass("org.objectweb.jonathan.libs.kernel.ClassPathFinderImplTest"));
   }
    
   public void testLoadArrayType() {
      try {
         ClassPathFinderImpl finder = new
               ClassPathFinderImpl(new URLClassLoader(new URL[] {new File("junit/src/org/objectweb/jonathan/libs/kernel/jar.jar").toURL()}));
         Class classe = finder.findClass("[[[Lorg.objectweb.jonathan.libs.kernel.NewClass;");
         assertEquals(classe.getName(),"[[[Lorg.objectweb.jonathan.libs.kernel.NewClass;");
      } catch (Exception e) {
         fail("exception caught: " + e.getMessage());
      }
   }

   public void testLoadPrimitiveArrayType() {
      try {
         ClassPathFinderImpl finder = new
               ClassPathFinderImpl(new URLClassLoader(new URL[] {new File("src/org/objectweb/jonathan/libs/kernel/jar.jar").toURL()}));
         Class classe = finder.findClass("[[[I");
         assertEquals(classe.getName(),"[[[I");
      } catch (Exception e) {
         fail("exception caught: " + e.getMessage());
      }
   }
}
