package org.objectweb.jonathan.libs.kernel;

import junit.framework.*;

import org.objectweb.jonathan.apis.kernel.Context;

public class KKernelTest extends TestCase {

   public KKernelTest(String name) {
      super(name);
   }

	public static void main(String args[]) {
		junit.textui.TestRunner.run(KKernelTest.class);
	}

   public void testRuntimeConfigurationFile() {
      System.setProperty("jonathan.KKernel.runtime_configuration_file",
                         "org/objectweb/jonathan/libs/kernel/KKernelRT.kcf");
      System.setProperty("test.property2","tutu");
      Context $boot_config = Kernel.newConfiguration(KKernelTest.class);
      assertEquals("est un hros",$boot_config.getValue("azertyuiop",(char) 0));
      assertEquals("titi",$boot_config.getValue("test/property",'/'));
      assertEquals("tutu",$boot_config.getValue("test/property2",'/'));
      //assertEquals("/test/subconf",$boot_config.getValue("test/subconf",'/').toString());
   }
   
   //     public void testRuntimeConfigurationFile2() {
   //        System.setProperty("jonathan.KKernel.runtime_configuration_file",
   //                           "file:///E:/utilisateurs/dumant/dev/Jonathan3.0/jonathan/tst/junit/src/org/objectweb/jonathan/libs/kernel/KKernelRT.kcf");
   //        System.setProperty("test.property2","tutu");
   //        Context $boot_config = Kernel.newConfiguration(KKernelTest.class);
   //        assertEquals("est un hros",$boot_config.getValue("azertyuiop",(char) 0));
   //        assertEquals("titi",$boot_config.getValue("test/property",'/'));
   //        assertEquals("tutu",$boot_config.getValue("test/property2",'/'));
   //        //assertEquals("/test/subconf",$boot_config.getValue("test/subconf",'/').toString());
   //     }
   
   public void testDifferentKernels() {
      Context $boot_config = Kernel.newConfiguration(KKernelTest.class);
      Context $other_boot_config = Kernel.newConfiguration(KKernelTest.class);
      assertEquals($boot_config,$other_boot_config);

      Context $yet_another = KKernel.newConfiguration($boot_config,KKernelTest.class);
      assert("Contexts should be different.",! $yet_another.equals($boot_config));
   }
}

