package org.objectweb.jonathan.libs.kernel.decoders;

import junit.framework.*;

import org.objectweb.jonathan.apis.kernel.Component;
import org.objectweb.jonathan.apis.kernel.Context;
import org.objectweb.jonathan.apis.kernel.Element;
import org.objectweb.jonathan.apis.kernel.MultiFactory;
import org.objectweb.jonathan.apis.kernel.ClassPathFinder;
import org.objectweb.jonathan.apis.kernel.decoders.File2Configuration;

import org.objectweb.jonathan.libs.kernel.JConfigurationFactory;

import org.objectweb.jonathan.libs.kernel.decoders.JAtom;

import java.util.Enumeration;
import java.util.Properties;


public class AtomTest extends TestCase {

   public AtomTest(String name) {
      super(name);
   }

   /** 
    * used by the test
    */
   public AtomTest() {
      super("");
   }

	public static void main(String args[]) {
		junit.textui.TestRunner.run(AtomTest.class);
	}   

   public void testImportXML() {
      try {
         Context $initial_context = BootKernel.newConfiguration(AtomTest.class);
         ClassPathFinder $finder = (ClassPathFinder) $initial_context.getValue("classpath_finder",(char) 0);
         File2Configuration $decoder = (File2Configuration) 
            $initial_context.getValue("jonathan/decoders/OpenXMLDecoder/instance",'/');
         
         JConfigurationFactory $context_factory = new JConfigurationFactory();

         Context $context = $context_factory.newContext(null,$finder);
         
         $decoder.importElement($context,
                                "org/objectweb/jonathan/libs/kernel/decoders/Atoms.kcf",
                                $context_factory,
                                $finder);
         actualTest($context);
      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }
   
   public void testGenerated() {
      try {
         actualTest(Atoms.newConfiguration(AtomTest.class));
      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }

   void actualTest(Context _context) {
      try {         
         Object $factory = _context.getValue("toto_factory",(char) 0);
         assert($factory != null);

         Component $component = _context.getComponent("toto_factory",(char) 0);
         Object $toto_factory = $component.getFactoryValue();
         assert("toto_factory is not a MultiFactory", $toto_factory instanceof MultiFactory);

         Object $component0 = _context.getValue("assemblage1",(char) 0);
         if ($component0 instanceof Toto) {
            assertEquals(((Toto) $component0).getIntValue(),0);
            assert(((Toto) $component0).getToto() == null);
         } else {
            assert("assemblage1 is not a Toto", false);         
         }

         Object $component1 = _context.getValue("assemblage2",(char) 0);
         if ($component1 instanceof Toto) {
            assertEquals(((Toto) $component1).getIntValue(),12);
            assert(((Toto) $component1).getToto() == null);
         } else {
            assert("assemblage2 is not a Toto", false);         
         }

         Object $component2 = _context.getValue("assemblage3",(char) 0);
         if ($component2 instanceof Toto) {
            assertEquals(((Toto) $component2).getIntValue(),16);
            assert(((Toto) $component2).getToto() != null);
         } else {
            assert("assemblage2 is not a Toto", false);         
         }

      } catch (Exception e) {
         e.printStackTrace();
         fail("Unexpected exception: " + e); 
      }
   }
}
