/***
 * Jonathan: an Open Distributed Processing Environment 
 * Copyright (C) 2001 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: jonathan@objectweb.org
 *
 * Author: Bruno Dumant
 *
 * -------------------------------------------------------------------
 * $Id: LazyComponent.java,v 1.1.1.1 2002/08/06 13:13:53 bmi Exp $
 * -------------------------------------------------------------------
 * 
 */

package org.objectweb.jonathan.libs.kernel.decoders;

import org.objectweb.jonathan.libs.kernel.JComponent;

/**
 * Lazy implementation of a runtime component. Its
 * initialization (configuration resolution & instanciation)
 * is called before each access to its type & value fields.
 */
public abstract class LazyComponent extends JComponent {

   protected boolean initialized;
   
   public LazyComponent() {
      super();
      initialized = false;
   }
         
   public Class getType(){
      initialize();
      return type;
   }
         
   public Object getValue() {
      initialize();
      return value;
   }
      
   public int getIntValue() {
      initialize();
      return int_value;
   }
      
   abstract protected void initialize();
}


