/***
 * Jonathan: an Open Distributed Processing Environment 
 * Copyright (C) 2001 Kelua SA
 * 
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 * 
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 * 
 * Contact: jonathan@objectweb.org
 *
 * Author: Bruno Dumant
 * 
 * --------------------------------------------------------------------------
 * $Id: OpenXMLDecoderFactory.java,v 1.1.1.1 2002/08/06 13:13:53 bmi Exp $
 * --------------------------------------------------------------------------
 */

package org.objectweb.jonathan.libs.kernel.decoders;

import org.objectweb.jonathan.apis.kernel.Context;
import org.objectweb.jonathan.apis.kernel.Factory;

/**
 * {@link OpenXMLDecoder} factory.
 */
public class OpenXMLDecoderFactory implements Factory {
   /**
    * Retrieves locally in the given context a {@link Context}
    * named <B>decoders</B> where the additional specified XML
    * to runtime component decoders are stored.
    * @param _c where OpenXMLDecoder parameters are stored
    * @return a new OpenXMLDecoder instance.
    */ 
   public Object newObject(Context _c) {
      if (_c != null) {
         Object $component = _c.getValue("decoders",(char) 0);
         if ($component instanceof Context) {
            return new OpenXMLDecoder((Context) $component);
         }
      }
      return new OpenXMLDecoder();
   }
}
